﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace TabControl
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		private MainViewModel model;
		public MainWindow()
		{
			InitializeComponent();
			this.model = new MainViewModel();
			this.DataContext = this.model;
		}

		public class MainViewModel : ViewModelBase
		{
			private ObservableCollection<TabItem> tabs;
			public MainViewModel()
			{
				this.Tabs = this.GenerateTabs();
			}

			private ObservableCollection<TabItem> GenerateTabs()
			{
				var items = new ObservableCollection<TabItem>();
				for (int i = 0; i < 10; i++)
				{
					items.Add(new TabItem() { Header = "Item " + i,IsTabEnabled = true });
				}
				return items;
			}

			public ObservableCollection<TabItem> Tabs
			{
				get
				{
					return this.tabs;
				}
				set
				{
					this.tabs = value;

					this.OnPropertyChanged("Tabs");
				}
			}
		}

		public class TabItem : ViewModelBase
		{
			private string header;
			private bool isTabEnabled;
			public string Header
			{
				get
				{
					return this.header;
				}
				set
				{
					this.header = value;
					this.OnPropertyChanged("Header");
				}
			}

			public bool IsTabEnabled
			{
				get
				{
					return this.isTabEnabled;
				}
				set
				{
					this.isTabEnabled = value;
					this.OnPropertyChanged("IsTabEnabled");
				}
			}
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			this.model.Tabs[1].IsTabEnabled = false;
		}
	}
}
